/********************************************************************************
* ׿ӹɷ޹˾
* (c) Copyright 2009-2015 ECTEK
* Ȩ
********************************************************************************
* ƣ
* ļ UDSInterface.c
*   UDS
* ü¼
* ע
* ޶¼
*                   汾                  
*   2017.07.03          00.01.00           һ
*******************************************************************************/

#include "UDSInterface.h"
#include "HardwareLib.h"
#include "CANNet.h"
#include "EOLData.h"

uint8 UDSInterface_CheckServiceCondition(uint8 idxSIDUB, uint8 stSubFuncUB)
{
	(void)stSubFuncUB;
	uint8 bResultUB=1;

	switch(idxSIDUB)
	{
		case _UDS_INDEX_COMMAND_SECURITYACCESS:
			/*27*/
			bResultUB=1;
			break;

	    case _UDS_INDEX_COMMAND_ECURESET:
	        /*ECU Reset*/
	        bResultUB=1;
	        break;

		case _UDS_INDEX_COMMAND_WRITEDATABYIDENTIFIER:
			/*Write Data By Identifier*/
			bResultUB=1;
			break;

		case _UDS_INDEX_COMMAND_CONTROLDTCSETTING:
			/*Control DTC Setting*/
			bResultUB=1;
			break;

		case _UDS_INDEX_COMMAND_STARTDIAGNOSTICSESSION:
		    /*Start Diagnostic Session*/
//		    if(stSubFuncUB==_UDS_INDEX_DIAG_PROGRAMMING)
//		    {
//		        //ȾԤ
//		        if(UDSInterface_bPrgPrecondChkedUB==1)
//		        {
//		            bResultUB=1;
//		        }
//		        else
//		        {
//		            bResultUB=0;
//		        }
//		    }
//		    else if(stSubFuncUB==_UDS_INDEX_DIAG_DEFAULT)
//		    {
//		        UDSInterface_bPrgPrecondChkedUB=0;
//		    }
//		    else
//		    {
//		    	bResultUB=1;
//		    }
			bResultUB=1;
		    break;

		default:
			bResultUB=1;
			break;
	}

	return bResultUB;
}

void UDSInterface_GetSeed(uint8 idxSecLvlUB, uint8 * dataSeedUBP)
{
//    uint32 datUI;

	switch(idxSecLvlUB)
	{
		case _UDS_INDEX_SEC_EXTENTED:
        	if(idxSecLvlUB==UDS_GetSecLvl())
        	{
        		/*İȫȼѽֵΪ0*/
        		dataSeedUBP[0]=0;
        		dataSeedUBP[1]=0;
        		dataSeedUBP[2]=0;
        		dataSeedUBP[3]=0;
        	}
        	else
        	{
        		dataSeedUBP[0]=11;//11
        		dataSeedUBP[1]=22;//22
        		dataSeedUBP[2]=33;//33
        		dataSeedUBP[3]=44;//44
        	}
			break;
		case _UDS_INDEX_SEC_ANTITHEFT:
        	if(idxSecLvlUB==UDS_GetSecLvl())
        	{
        		/*İȫȼѽֵΪ0*/
        		dataSeedUBP[0]=0;
        		dataSeedUBP[1]=0;
        		dataSeedUBP[2]=0;
        		dataSeedUBP[3]=0;
        	}
        	else
        	{
        		dataSeedUBP[0]=0x55;
        		dataSeedUBP[1]=0x66;
        		dataSeedUBP[2]=0x77;
        		dataSeedUBP[3]=0x88;
        	}
			break;
        default:
			dataSeedUBP[0]=0x00;
			dataSeedUBP[1]=0x00;
			dataSeedUBP[2]=0x00;
			dataSeedUBP[3]=0x00;
            break;
	}
}

void UDSInterface_GetKey(uint8 idxSecLvlUB, uint8 * dataSeedUBP, uint8 * dataKeyUBP)
{
	uint8 Count; //ѭ
	uint8 Dir; //ѭλ0-1
	uint8 Pattern; //ģʽƥ
	uint8 Select; //ѡMASK
	uint8 i; //ѭ
	uint32 seed; //мתSEED

	uint32 mask[4]={0x5DEC1836,0x5DEC1836,0x5DEC1836,0x5DEC1836}; //mask
	switch(idxSecLvlUB)
	{
		case _UDS_INDEX_SEC_EXTENTED:
		case _UDS_INDEX_SEC_ANTITHEFT:
			Count=dataSeedUBP[1]&0x0F;
			Select=(dataSeedUBP[3]&0x30)>>4;

			seed=((uint32)dataSeedUBP[0]<<24)+((uint32)dataSeedUBP[1]<<16)+((uint32)dataSeedUBP[2]<<8)+((uint32)dataSeedUBP[3]);

			for(i=0;i<Count;i++)
			{
				Pattern=((uint8)seed)&0x07;
				Dir=(((uint8)seed)&0x08)>>3;

				if(Pattern!=0b101)
				{
					if(Dir==1)
					{
						seed=seed/2+((seed&0x00000001)<<31);//
					}
					else
					{
						seed=seed*2+((seed&0x80000000)>>31);//
					}
				}
				else
				{
					break;
				}
			}
			seed=seed^mask[Select];
			for(i=0;i<4;i++)
			{
				dataKeyUBP[i]=(uint8)(seed>>((3-i)*8));
			}
			break;
        default:
            break;
	}
}

/*0x31 ̿ƻص*/
uint8 UDSInterface_RoutineTestCallback(uint16 numRecvLenUW, uint8 * datRecvBuffUBP, uint16 * numSendLenUWP, uint8 * datSendBuffUBP)
{
    if(numRecvLenUW>3)
    {
        switch(datRecvBuffUBP[0]&0x7F) //suppressPosRspMsgIndicationBit supported
        {
            case _UDS_ROUTINECONTROL_START:
                break;
            case _UDS_ROUTINECONTROL_STOP:
                break;
            case _UDS_ROUTINECONTROL_REQUESTRESULTS:
                break;
            default:
                break;
        }
    }
    else
    {
        return _UDS_INDEX_ERROR_INVALIDFORMAT;
    }

    *numSendLenUWP=4;
    datSendBuffUBP[0]=0x11;
    datSendBuffUBP[1]=0x22;
    datSendBuffUBP[2]=0x33;
    datSendBuffUBP[3]=0x44;

    return 0;
}

/*0x2F ̿ƻص*/
uint8 UDSInterface_IOControlCallback(uint16 numRecvLenUW, uint8 * datRecvBuffUBP, uint16 * numSendLenUWP, uint8 * datSendBuffUBP)
{
    if(numRecvLenUW>3)
    {
        switch(datRecvBuffUBP[0]&0x7F) //suppressPosRspMsgIndicationBit supported
        {
            case _UDS_ROUTINECONTROL_START:
                break;
            case _UDS_ROUTINECONTROL_STOP:
                break;
            case _UDS_ROUTINECONTROL_REQUESTRESULTS:
                break;
            default:
                break;
        }
    }
    else
    {
        return _UDS_INDEX_ERROR_INVALIDFORMAT;
    }

    *numSendLenUWP=4;
    datSendBuffUBP[0]=0x11;
    datSendBuffUBP[1]=0x22;
    datSendBuffUBP[2]=0x33;
    datSendBuffUBP[3]=0x44;

    return 0;
}


