/********************************************************************************
 * ׿ӹɷ޹˾
 * (c) Copyright 2009-2017 ECTEK
 * Ȩ
 ********************************************************************************
 * ƣ
 * ļ HardwareLib.h
 *   ײӲܿ
 * ü¼ļGlobalDef.h
 * ע
 * ޶¼
 *				      汾		  		
 *   2017.05.08  00.01.00     
 *******************************************************************************/

#ifndef __HARDWARELIB_H
#define __HARDWARELIB_H

#include "Std_Types.h"

/*******************************************************************************************
                             ú
********************************************************************************************/
#define getbit(x, y) ((x) >> (y)&1) //ȡxĵyλֵ
#define setbit(x, y) x |= (1 << y)  // xĵyλ1
#define clrbit(x, y) x &= ~(1 << y) // xĵyλ0

//һάֵ
uint16 Intpol_u16u16(uint16 *addrTablePUW, uint16 dataXUW); // 1άֵX,Y16λ޷
uint16 Intpol_s16u16(uint16 *addrTablePUW, sint16 dataXW);  // 1άֵXзY޷
sint16 Intpol_u16s16(uint16 *addrTablePUW, uint16 dataXUW); // 1άֵX޷Yз
sint16 Intpol_s16s16(uint16 *addrTablePUW, sint16 dataXW);  // 1άֵX,Y16λз
uint32 Intpol_u16u32(uint16 *addrTablePUW, uint16 dataXUW); // 1άֵX16λ޷Y޷32λ
uint32 Intpol_u32u32(uint16 *addrTablePUW, uint32 dataXUI); // 1άֵX,Y32λ޷

//άֵ
uint16 Intpol_u16u16u16(uint16 *addrTablePUW, uint16 dataXUW, uint16 dataYUW); // 2άֵX,Y,Z16λ޷
sint16 Intpol_u16u16s16(uint16 *addrTablePUW, uint16 dataXUW, uint16 dataYUW); // 2άֵX,Y16λ޷ţZз
uint16 Intpol_u16s16u16(uint16 *addrTablePUW, uint16 dataXUW, sint16 dataYW);  // 2άֵX,Z16λ޷ţYз
sint16 Intpol_s16u16s16(uint16 *addrTablePUW, sint16 dataXW, uint16 dataYUW);  // 2άֵX,Z16λзţY޷
uint32 Intpol_u16u16u32(uint16 *addrTablePUW, uint16 dataXUW, uint16 dataYUW); // 2άֵX,Y޷16λ,Z32λ޷

// PT1˲
#define _COMLIB_FACTOR_PT1 1000

void ComLib_PT1U8(uint8 valRawUB, uint16 K, uint16 T1, uint8 *valLstUB);
void ComLib_PT1S8(sint8 valRawB, uint16 K, uint16 T1, sint8 *valLstB);
void ComLib_PT1U16(uint16 valRawUW, uint16 K, uint16 T1, uint16 *valLstUW);
void ComLib_PT1S16(sint16 valRawW, uint16 K, uint16 T1, sint16 *valLstW);
void ComLib_PT1U32(uint32 valRawUI, uint16 K, uint16 T1, uint32 *valLstUI);
void ComLib_PT1S32(sint32 valRawI, uint16 K, uint16 T1, sint32 *valLstI);

/*******************************************************************************************
                             ײӿ
********************************************************************************************/

typedef enum
{
    DSM_DIAG_OPENLOAD = 0, /*·*/
    DSM_DIAG_SHORTCIRCUIT, /*·*/
    DSM_DIAG_SHORTTOGND,   /*·*/
    DSM_DIAG_SHORTTOPWR    /*·Դ*/
} DSM_idxDiagTypeE_TYPE;

typedef enum
{
    DSM_STATUS_OK = 0x0,   /*޹*/
    DSM_STATUS_ERR = 0x1,  /*й*/
    DSM_STATUS_NVA = 0xFF, /*״̬δ֪Ч*/
} DSM_stDiagE_TYPE;

#define _PWM_DUTYCYCLE_FULL 10000U // 10000ʾռձΪ100.00%
#define _PWM_DUTYCYCLE_FACTOR 100U

#define _PWM_FREQ_FACTOR 10U //Ƶʾ0.1Hz

//ģ********************************************************************************************
#define _ATD_NUM_CHAN 24

#define _ATD_INDEX_BAK1_CHAN 0      // BAK1źţӦӲX64
#define _ATD_INDEX_BAK2_CHAN 1      // BAK2źţӦӲX26
#define _ATD_INDEX_BAK3_CHAN 2      // BAK3źţӦӲX27
#define _ATD_INDEX_BAK4_CHAN 3      // BAK4źţӦӲX35
#define _ATD_INDEX_BAK5_CHAN 4      // BAK5źţӦӲX30
#define _ATD_INDEX_BAK6_CHAN 5      // BAK6źţӦӲX31
#define _ATD_INDEX_DI9_CHAN 6       // DI9źţӦӲX15
#define _ATD_INDEX_DI8_CHAN 7       // DI8źţӦӲX11
#define _ATD_INDEX_DI10_CHAN 8      // DI10źţӦӲX4
#define _ATD_INDEX_BRAKE1_CHAN 10   //ƶ1ӦӲX58
#define _ATD_INDEX_ACCPED2_CHAN 11  //̤2ӦӲX63
#define _ATD_INDEX_DI7_CHAN 12      // DI7źţӦӲX5
#define _ATD_INDEX_DI1_CHAN 14      // DI1źţӦӲX10
#define _ATD_INDEX_DI6_CHAN 15      // DI6źţӦӲX9
#define _ATD_INDEX_BRAKE2_CHAN 16   //ƶ2ӦӲX61
#define _ATD_INDEX_ACCPED1_CHAN 17  //̤1ӦӲX62
#define _ATD_INDEX_DI5_CHAN 19      // DI5źţӦӲX14
#define _ATD_INDEX_DI4_CHAN 20      // DI4źţӦӲX13
#define _ATD_INDEX_DI3_CHAN 21      // DI3źţӦӲX18
#define _ATD_INDEX_DI2_CHAN 22      // DI2źţӦӲX17
#define _ATD_INDEX_UBATTERY_CHAN 23 //صѹڲ
                                    //ģ¶(APP)
#define _ATD_INDEX_AIRPRESSURE 17   //ѹӦӲXK62
#define _ATD_INDEX_PLUGINTEMP1 2    //Ӳ¶1ӦӲXK27
#define _ATD_INDEX_PLUGINTEMP2 3    //Ӳ¶2ӦӲXK35
#define _ATD_INDEX_PLUGINTEMP3 4    //Ӳ¶3ӦӲXK30
#define _ATD_INDEX_PLUGINTEMP4 5    //Ӳ¶4ӦӲXK31

uint16 ATDDrv_GetChanResult(uint8 idxChanUB); //õͨĵѹֵѹֵ1/4095V/bit
//********************************************************************************************

//********************************************************************************************
#define _DIN_NUM_CHAN 16
#define _DIN_NUM_ADCHAN 10 //ǰ10·ͨADͨʵ

#define _DIN_OPENLVL_LOW_STATE 0
#define _DIN_OPENLVL_HIGH_STATE 1

#define _DIN_INDEX_BAK1_CHAN 0     //1źţӦӲX10
#define _DIN_INDEX_BAK2_CHAN 1     //2źţӦӲX17
#define _DIN_INDEX_BAK3_CHAN 2     //3źţӦӲX18
#define _DIN_INDEX_BAK4_CHAN 3     //4źţӦӲX13
#define _DIN_INDEX_BAK5_CHAN 4     //5źţӦӲX14
#define _DIN_INDEX_BAK6_CHAN 5     //6źţӦӲX9
#define _DIN_INDEX_BAK7_CHAN 6     //7źţӦӲX5
#define _DIN_INDEX_BAK8_CHAN 7     //8źţӦӲX11
#define _DIN_INDEX_BAK9_CHAN 8     //9źţӦӲX15
#define _DIN_INDEX_BAK10_CHAN 9    //10źţӦӲX4
#define _DIN_INDEX_BAK11_CHAN 10   //11źţӦӲX7
#define _DIN_INDEX_BAK12_CHAN 11   //12źţӦӲX6
#define _DIN_INDEX_BAK13_CHAN 12   //13źţӦӲX3
#define _DIN_INDEX_BAK14_CHAN 13   //14źţӦӲX19
#define _DIN_INDEX_BAK15_CHAN 14   //15źţӦӲX22
#define _DIN_INDEX_BAK16_CHAN 15   //16źţӦӲX23
                                   //¶(APP)
#define _DIN_INDEX_UNLOCKSENSOR1 0 //ӦӲXK10ɿ1õЧ
#define _DIN_INDEX_UNLOCKSENSOR2 7 //ӦӲXK11ɿ2õЧ
#define _DIN_INDEX_UNLOCKSENSOR3 3 //ӦӲXK13ɿ3õЧ
#define _DIN_INDEX_UNLOCKSENSOR4 4 //ӦӲXK14ɿ4õЧ

#define _DIN_INDEX_LOCKSENSOR1 8 //ӦӲXK15н1õЧ
#define _DIN_INDEX_LOCKSENSOR2 1 //ӦӲXK17н2õЧ
#define _DIN_INDEX_LOCKSENSOR3 2 //ӦӲXK18н3õЧ
#define _DIN_INDEX_LOCKSENSOR4 6 //ӦӲXK5н4õЧ

#define _DIN_INDEX_READYSENSOR1 11 //ӦӲXK61Ч
#define _DIN_INDEX_READYSENSOR2 10 //ӦӲXK72Ч
#define _DIN_INDEX_PLUGHVLOCK 12   //ӦӲXK3Ӳ1Ч,ŵӲ
void DINDrv_SetChanThres(uint8 idxChanUB, uint8 stOpenLvlUB, uint16 uThresUW);
uint8 DINDrv_GetChanState(uint8 idxChanUB); //õͨ״̬
//********************************************************************************************

//********************************************************************************************
#define _DO_NUM_CHAN 1

#define _DO_INDEX_CPCTL_CHAN 0 // CP·

void DODrv_SetChanState(uint8 idxChanUB, uint8 bLvlUB); // bLvlUBʾƽ״̬0Ϊ͵ƽ1Ϊߵƽ
//********************************************************************************************

//Ƶɼ********************************************************************************************
#define _PULSEACQ_NUM_CHAN 2

#define _PULSEACQ_INDEX_CP_CHAN 0   //ͷCPźŲɼӦӲX21
#define _PULSEACQ_INDEX_BAK2_CHAN 1 //Ƶź1ɼӦӲX39
                                    //Ƶɼ¶(APP)
#define _PULSEACQ_INDEX_HVLOCK2 1   //ѹPWMɼӦӲXK39

void PulseAcqDrv_GetChanFreq(uint8 idxChanUB, uint32 *fFreqUIP, uint16 *rDutyUWP);    //ȡͨƵϢƵʾ0.1Hz/bitռձȾ0.01%/bit
void PulseAcqDrv_GetChanDura(uint8 idxChanUB, uint32 *tiPeriodUIP, uint32 *tiPosUIP); //ȡͨʱϢʱ侫0.02us/bit
//********************************************************************************************

//ģ********************************************************************************************
#define _AO_NUM_CHAN 2

#define _AO_INDEX_ACCPED1_CHAN 0 //ģź1ӦӲX27
#define _AO_INDEX_ACCPED2_CHAN 1 //ģź2ӦӲX31

void AODrv_Interface(uint8 idxChanUB, uint16 uSetpointUW); //ģĿѹֵѹֵ1/4095V/bit
//********************************************************************************************

// PWMźƵ͵ͱ********************************************************************************************
#define _PPWM_NUM_CHAN 12

#define _PPWM_INDEX_FHBAK1_CHAN 0 //߱1ӦӲX36
#define _PPWM_INDEX_FHBAK2_CHAN 1 //߱2ӦӲX32
#define _PPWM_INDEX_FHBAK3_CHAN 2 //߱3ӦӲX28
#define _PPWM_INDEX_FHBAK4_CHAN 3 //߱4ӦӲX24
#define _PPWM_INDEX_FHBAK5_CHAN 4 //߱5ӦӲX20
#define _PPWM_INDEX_FHBAK6_CHAN 5 //߱6ӦӲX16
#define _PPWM_INDEX_FHBAK7_CHAN 6 //߱7ӦӲX12
#define _PPWM_INDEX_FHBAK8_CHAN 7 //߱8ӦӲX8
#define _PPWM_INDEX_FBAK1_CHAN 8  //Ƶʵͱ1ӦӲX38
#define _PPWM_INDEX_FBAK2_CHAN 9  //Ƶʵͱ2ӦӲX40
#define _PPWM_INDEX_FBAK3_CHAN 10 //Ƶʵͱ3ӦӲX45
#define _PPWM_INDEX_FBAK4_CHAN 11 //Ƶʵͱ4ӦӲX46
                                  //Ƶ¶(APP)
#define _PPWM_INDEX_HVLOCK2 8     //ѹPWMӦӲXK38
//ú10msе
void PPWMDrv_Interface(uint8 idxChanUB, uint32 fSetUI, uint16 rSetUW); //ͨĵͱƵʼռձȣƵʾ0.1Hz/bitռձȾ0.01%/bit
DSM_stDiagE_TYPE PPWMDrv_GetChanDiagInfo(uint8 idxChanUB, DSM_idxDiagTypeE_TYPE idxDiagTypeE);
//********************************************************************************************

//ߵͱ********************************************************************************************
#define _PSWT_NUM_CHAN 17

#define _PSWT_INDEX_HBAK1_CHAN 0      //߱1ӦӲX36
#define _PSWT_INDEX_HBAK2_CHAN 1      //߱2ӦӲX32
#define _PSWT_INDEX_HBAK3_CHAN 2      //߱3ӦӲX28
#define _PSWT_INDEX_HBAK4_CHAN 3      //߱4ӦӲX24
#define _PSWT_INDEX_HBAK5_CHAN 4      //߱5ӦӲX20
#define _PSWT_INDEX_HBAK6_CHAN 5      //߱6ӦӲX16
#define _PSWT_INDEX_HBAK7_CHAN 6      //߱7ӦӲX12
#define _PSWT_INDEX_HBAK8_CHAN 7      //߱8ӦӲX8
#define _PSWT_INDEX_LBAK1_CHAN 8      //ͱ1ӦӲX34
#define _PSWT_INDEX_LBAK2_CHAN 9      //ͱ2ӦӲX44
#define _PSWT_INDEX_LBAK3_CHAN 10     //ͱ3ӦӲX41
#define _PSWT_INDEX_LBAK4_CHAN 11     //ͱ4ӦӲX43
#define _PSWT_INDEX_LBAK5_CHAN 12     //ͱ5ӦӲX37
#define _PSWT_INDEX_LBAK6_CHAN 13     //ͱ6ӦӲX42
#define _PSWT_INDEX_LBAK7_CHAN 14     //ͱ7ӦӲX47
#define _PSWT_INDEX_LBAK8_CHAN 15     //ͱ8ӦӲX48
#define _PSWT_INDEX_MAINRELAY_CHAN 16 //ʵ̵ӦӲX33
                                      //¶(APP)
#define _PSWT_INDEX_AIRCONTROL 0      //ŷƣӦӲXK36
#define _PSWT_INDEX_EBCLEDCONTROL 1   //LEDƣӦӲXK32
#define _PSWT_INDEX_BLEPWRCONTROL 2   //ԴƣӦӲXK28
#define _M1_C 8                       // M1-ƣӦӲX34
#define _M2_C 9                       // M2-ƣӦӲX44
#define _M3_C 10                      // M3-ƣӦӲX41
#define _M4_C 11                      // M4-ƣӦӲX43

#define _M_D_C 15 // M4-תƣӦӲX48
//ú10msе
void PSwtDrv_Interface(uint8 idxChanUB, uint8 bOpenUB); //ͨĵͱ״̬, bOpen=1ʱΪ, Ϊر
DSM_stDiagE_TYPE PSwtDrv_GetChanDiagInfo(uint8 idxChanUB, DSM_idxDiagTypeE_TYPE idxDiagTypeE);
//********************************************************************************************

// CANͨѶӿ********************************************************************************************
#define _MCAN_NUM_CHAN 3
/*
 * CAN0߱32շ,Դ
 * CAN1߱64շ,CAN
 * CAN2߱32շ,MO24~31ɵײCCPUDSЭռ
 */

#define _MCAN_DIR_RX 0
#define _MCAN_DIR_TX 1

#define _MCAN_IDE_STD 0
#define _MCAN_IDE_EXT 1

typedef enum
{
    MCAN_Status_ok = 0x00000000,
    MCAN_Status_notInitialised = 0x00000001,
    MCAN_Status_wrongParam = 0x00000002,
    MCAN_Status_wrongPin = 0x00000004,
    MCAN_Status_busHeavy = 0x00000008,
    MCAN_Status_busOff = 0x00000010,
    MCAN_Status_notSentBusy = 0x00000020,
    MCAN_Status_receiveEmpty = 0x00000040,
    MCAN_Status_messageLost = 0x00000080,
    MCAN_Status_newData = 0x00000100,
    MCAN_Status_newDataButOneLost = MCAN_Status_messageLost | MCAN_Status_newData
} MCAN_stRetE_TYPE;

typedef enum
{
    MCAN_NODEMODE_MO = 0,  // MOģʽ£ÿMOӦһı
    MCAN_NODEMODE_BUF = 1, // BUFģʽʹһMOMOΪͻ
    MCAN_NODEMODE_UNKNOWN = 0xFF,
} MCANDrv_idxNodeModeE_TYPE;

typedef union
{
    uint32 U;
    struct
    {
        uint32 DLC : 8; //ݳ
        uint32 DIR : 1; // 0Ϊգ1Ϊ
        uint32 IDE : 1; // 0Ϊ׼֡1Ϊչ֡
        uint32 Reserved : 6;
        uint32 CAN : 8; // CANͨ
        uint32 MO : 8;  // MO
    } B;
} MCANDrv_infoMsgParU_TYPE;

typedef struct
{
    MCANDrv_infoMsgParU_TYPE infoMsgParU;
    uint32 infoMsgIDUI;
} MCANDrv_infoMsgConfS_TYPE;

typedef struct
{
    MCANDrv_infoMsgConfS_TYPE infoConfS;
    uint8 datMsgUBA[8];
} MCANDrv_infoMsgS_TYPE;

typedef void (*pFunc_TxMsgCallback)(void);
typedef void (*pFunc_RxMsgCallback)(MCANDrv_infoMsgS_TYPE infoMsgS);

/*CANú*/
uint8 MCANDrv_SetBaudrate(uint8 idxCANUB, uint32 baudrateUI);
uint8 MCANDrv_SetCANMode(uint8 idxCANUB, MCANDrv_idxNodeModeE_TYPE idxNodeModeE);
uint8 MCANDrv_SetMsgObj(const MCANDrv_infoMsgConfS_TYPE infoMsgConfS, void *pFunc);
uint8 MCANDrv_SetCallbackFunc(uint8 idxCANUB, const pFunc_RxMsgCallback pRxFunc, const pFunc_TxMsgCallback pTxFunc);

/*CAN*/
MCAN_stRetE_TYPE MCANDrv_SendMsg(const MCANDrv_infoMsgS_TYPE infMsgS);

uint8 MCANDrv_CheckIfBusOff(uint8 idxCANUB); //1ʾbusoff
//********************************************************************************************

/*EEPROMӿ*/
extern uint8 EEPROMDrv_bSaveInstantUB; //EEPROMĴ洢1ɲѯֵΪ0ʱʾ洢

/*******************************************************************************************
                             ײѴ
********************************************************************************************/
extern uint16 BattCD_uFltUW;          //صѹ1/100V/bit
extern uint16 BattCD_tPwrChipUW;      //ԴоƬ¶
extern uint32 SysCon_tiRunHighResiUI; //ϵͳʱ

typedef union
{
    uint8 U;
    struct
    {
        uint8 bCAN : 1;
        uint8 bLogic : 1;
        uint8 bWkpSig1 : 1;
        uint8 bWkpSig2 : 1;
        uint8 : 4;
    } B;
} BattCD_stWakeupU_TYPE;

extern BattCD_stWakeupU_TYPE BattCD_stWakeupU;

extern uint8 HardwareDrv_bBootloaderReqUB; //Bootloader󣬵ָʱὫBattCD_stWakeupU㣬ڽAfterrunʱн밲ȫ״̬Ĳ

/*******************************************************************************************
                            ״̬
*******************************************************************************************/
extern uint32 SysCon_tiRunLowUI; //ϴθλϵͳʱ䣬λs

/*******************************************************************************************
 * Ϲģӿ
 ******************************************************************************************/

/*******************************************************************************************
                              
********************************************************************************************/
#define _DSM_NUM_CONF_DFC_CHECKS 100  /*ĹϺ*/
#define _DSM_NUM_CONF_DINH_FIDS 32    /*ĹϽֹ*/
#define _DSM_NUM_CONF_DFES_ENTRIES 20 /*洢ⱨ͵Ĺ*/
#define _DINH_NUM_DFC_FID_MAX 6       /*ÿϺɹĹϽֹ*/

/*ϺŶDFC*/
/*********************************************************************************************/
/**/
#ifdef _SAMPLE_CODE_

#define _DFC_INDEX_ACCPED_SIGHIGH 0  /*1źACCPED*/
#define _DFC_INDEX_ACCPED_SIGLOW 1   /*1źACCPED*/
#define _DFC_INDEX_ACCPED_SIGHNPL 2  /*źACCPED*/
#define _DFC_INDEX_ACCPED2_SIGHIGH 3 /*2źACCPED*/
#define _DFC_INDEX_ACCPED2_SIGLOW 4  /*2źACCPED*/

#endif //_SAMPLE_CODE_
/*********************************************************************************************/

/*ϽֹFID*/
/*ײFID*/
#define _DINH_INDEX_FID_DSM_WUC 0 /*ϵͳůѭǷֹ*/
#define _DINH_INDEX_FID_DSM_TST 1 /*߼ιǷʹ*/

/*********************************************************************************************/
/**/
#ifdef _SAMPLE_CODE_

#define _DINH_INDEX_FID_APP1 2       /*̤1źŹʧЧģʽ*/
#define _DINH_INDEX_FID_APP2 3       /*̤2źŹʧЧģʽ*/
#define _DINH_INDEX_FID_ACCPED_NPL 4 /*12 л*/

#endif //_SAMPLE_CODE_
/*********************************************************************************************/

extern uint8 DFES_numMilUB;    /*ϵƵMemory EntryĿ*/
extern uint8 DFES_numSvsUB;    /*ά޵ƵMemory EntryĿ*/
extern uint8 DFES_bMilOnUB;    /*ϵǷ*/
extern uint8 DFES_bMilBlinkUB; /*ϵǷ˸*/

/*DFC״*/
/*ʹþ:*/
/*DFC_ReportFaultLevel(_DFC_INDEX_FTS_SIGHIGH,_DDRC_MASK_ANA_FT_LV_OK);*/
/*DFC_ReportFaultLevel(_DFC_INDEX_FTS_SIGLOW,_DDRC_MASK_ANA_FT_LV_ERROR);*/
#define _DDRC_MASK_ANA_FT_LV_OK 0x0
#define _DDRC_MASK_ANA_FT_LV_ERROR 0xF

void DFC_ReportFaultLevel(uint16 idxDFCUW, uint8 stFaultLevelUB);

/*ȡDFCĹ״̬*/
/*ֵΪ0ʱʾDFC޹ϣֵΪ1ʱʾDFC*/
uint8 DFC_GetErrState(uint16 idxDFCUW);

/*ȡDFCĹۻ״̬*/
#define _DFC_INDEX_PRELIMINARILY_DEFECTIVE_STATUS 1
#define _DFC_INDEX_FINALLY_DEFECTIVE_STATUS 2
#define _DFC_INDEX_PRELIMINARILY_HEALED_STATUS 3
#define _DFC_INDEX_FINALLY_HEALED_STATUS 4

uint8 DFC_GetDebState(uint16 idxDFCUW);

/*ȡFID״̬*/
/*ֵΪ0ʱʾδFIDΪ1ʱʾ˸FID*/
uint8 DINH_GetFIDState(uint8 idxFIDUB);

#endif
