/*
 * CanVar.c
 *
 *  Created on: 20211227
 *  
 *      Author: QiXiang_CHENJIE
 */
#include "CanVar.h"
UINT32 BcuInTable[28] = {
	0x1801D0F3,
	0x1801D8F3,
	0x1880D0F3,
	0x1881D0F3,
	0x1882D0F3,
	0x1883D0F3,
	0x1884D0F3,
	0x1885D0F3,
	0x1886D0F3,
	0x1887D0F3,
	0x1888D0F3,
	0x1889D0F3,
	0x188AD0F3,
	0x18C1D0F3,
	0x18C2D0F3,
	0x18E1D0F3,
	0x18E2D0F3,
	0x18E3D0F3,
	0x18E4D0F3,
	0x18E5D0F3,
	0x18E6D0F3,
	0x18F1D0F3,
	0x18F2D0F3,
	0x18F3D0F3,
	0x18F4D0F3,
	0x18F5D0F3,
	0x18FF45F4,
	0x18FFC13A,
};

BOOL BcuRxShortError[28];
BOOL BcuRxLongError[28];
UINT8 BcuRxErrorCounter[28];
UINT8 BcuRxFlag[28];
/************************************************************
 *BCU->Ebc
 ************************************************************/
UINT8 BMS_ReqVIN = 0x00;					  //ǷVIN,0:Ԥ;1:VIN;2:VIN;3:Ч;,Re-1,Off-0,
UINT8 BMS_ReqHVOff = 0x00;					  //Ƿ¸ѹ,0:Ԥ;1:¸ѹ;2:¸ѹ;3:Ч;,Re-1,Off-0,
UINT8 BMS_ProtocolEditionH = 0x00;			  //ͨѶЭ汾λ( : 汾Ϊ3 .1, ˴3),	, Re - 1, Off - 0,
UINT8 BMS_ProtocolEditionL = 0x00;			  //ͨѶЭ汾λ( : 汾Ϊ3 .1, ˴1),	, Re - 1, Off - 0,
UINT8 BMS_CharDevNum = 0x00;				  //ɳװϵͳ(BMSпɳװϵͳеĵڼ, Ҫ֪),1,Re-1,Off-0,
UINT8 BMS_FtPosRly = 0x00;					  //̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNegRly = 0x00;					  //̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtPosCharRly1 = 0x00;				  //1̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNegCharRly1 = 0x00;				  //为1̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtPosCharRly2 = 0x00;				  //2̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNegCharRly2 = 0x00;				  //为2̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtHeatRly1 = 0x00;				  //1/̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtHeatRly2 = 0x00;				  //2/̵ճ,0:; 1:,Re-1,Off-0,
UINT8 BMS_StPosRly = 0x00;					  //̵״̬(̵״̬BMS),0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_StNegRly = 0x00;					  //̵״̬(̵״̬BMS),0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_StPreCharRly = 0x00;				  //Ԥ̵״̬,0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_StPosCharRly1 = 0x00;				  //̵ֱ1״̬,0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_StNegCharRly1 = 0x00;				  //ֱ为̵1״̬,0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_StPosCharRly2 = 0x00;				  //̵ֱ2״̬,0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_StNegCharRly2 = 0x00;				  //ֱ为̵2״̬,0:Ԥ;1:;2:պ;3:Ч;,Re-1,Off-0,
UINT8 BMS_FtAuxRelayWeld = 0x00;			  //̵ճ(),0:; 1:,Re-1,Off-0,
UINT8 BMS_BraOpenCirc = 0x00;				  //֧··,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtBackCharCurrOutLim = 0x00;		  //سޱ,0:1 : 1 ΢ 2 : 2 ع 3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtPosRlyOpen = 0x00;				  //̵޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNegRlyOpen = 0x00;				  //̵޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtPosCharRly1Open = 0x00;			  //ֱ1̵޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtPosCharRly2Open = 0x00;			  //ֱ2̵޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNegCharRly1Open = 0x00;			  //ֱ縺1̵޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNegCharRly2Open = 0x00;			  //ֱ縺2̵޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtTMSContClose = 0x00;			  //ĤTMSӴ޷Ͽ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtTMSContOpen = 0x00;				  //ĤTMSӴ޷պϱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtTMS = 0x00;						  //ȹϵͳ,0:; 1:,Re-1,Off-0,
UINT8 BMS_Ft24VSpy = 0x00;					  // BMS 24V쳣,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtPACKSelfProt = 0x00;			  //ذԱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtCharSockTempOver = 0x00;		  //±,0:1 : 1 ΢ 2 : 2 ع 3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtTempOutCtrl = 0x00;				  //ʧر,0:; 1:,Re-1,Off-0,
UINT8 BMS_StPosHeatRly = 0x00;				  //̵״̬,0:;1:;2:պ;3:Ч,Re-1,Off-0,
UINT8 BMS_StNegHeatRly = 0x00;				  //ȸ̵״̬,0:;1:;2:պ;3:Ч,Re-1,Off-0,
UINT8 BMS_CharSysNum = 0x00;				  //ɳ索ϵͳ(),,Re-1,Off-0,
UINT8 BMS_FtCode = 0x00;					  //ϵͳ,ϵͳб,Re-1,Off-0,
UINT8 BMS_ST1CheckSum = 0x00;				  // B2V_ST1CheckSum,Byte0=Byte1 XOR Byte2 XOR Byte3 XOR Byte4 XOR Byte5 XOR Byte6 XOR Byte7,Re-1,Off-0,
UINT8 BMS_ST1Counter = 0x00;				  // B2V_ST1ź,0~14ѭ,15:źЧ,Re-1,Off-0,
UINT8 BMS_Mode = 0x00;						  // BMSǰ״̬,0:Ԥ;1:ѹϵ;2:ѹµ;3:Ч;,Re-1,Off-0,
UINT8 BMS_AuxRlySt = 0x00;					  //̵״̬,0:;1:պ;,Re-1,Off-0,
UINT8 BMS_BattBalaSt = 0x00;				  // BMSǰ״̬,0:δ;1:;,Re-1,Off-0,
UINT8 BMS_CharGunSt = 0x00;					  //ֱǹ״̬,0:δ1 : , Re - 1, Off - 0,
UINT8 BMS_CharMode = 0x00;					  // BMSǰģʽ,0:Ԥ1 : ֱ 2 :  3 : , Re - 1, Off - 0,
UINT8 BMS_CharSt = 0x00;					  //״̬,0:Գ1 : ڳ 2 :  3 : , Re - 1, Off - 0,
UINT8 BMS_FtLvl = 0x00;						  //ǰ߹ϵȼ,0:1 : 1 ΢ 2 : 2 ع 3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCellTempDiff = 0x00;			  //о²쳣,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCellTempHigh = 0x00;			  //о¶ȹ߱,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtPACKOverVolt = 0x00;			  // PACKѹ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtPACKUndeVolt = 0x00;			  // PACKǷѹ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtSOCLow = 0x00;					  // SOCͱ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCellOverVolt = 0x00;			  //ѹ߱,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCellUndeVolt = 0x00;			  //ѹǷѹ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtIns = 0x00;						  //Ե,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCellOverVoltDiff = 0x00;		  //ѹ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCharCurrOver = 0x00;			  //󱨾,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtDisCharCurrOver = 0x00;			  //ŵ󱨾,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtCellTempLow = 0x00;				  //о¶ȹͱ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtBranVoltDifOver = 0x00;			  //֧·ѹ󱨾(ڲ֧·ϵͳ),0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtBMSHardWare = 0x00;				  // BMSӲ,0:޹; 1:1 ΢; 2:2 ع3 : 3 ع, Re - 1, Off - 0,
UINT8 BMS_FtSOCHigh = 0x00;					  // SOC߱,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtSOCJump = 0x00;					  // SOC䱨,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtInCom = 0x00;					  // BMSڲͨŹ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtSysMism = 0x00;					  // BMS/ɳ索ϵͳƥ䱨,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtHvIntLock = 0x00;				  //ѹ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtSmoke = 0x00;					  //̽,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtFire = 0x00;					  //ذֱ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtNum = 0x00;						  // BMSǰĹĿ(GB32960й涨ĹĿ),,Re-1,Off-0,
UINT8 BMS_PackSOC = 0x00;					  //ذSOC,,Re-0.4,Off-0,
UINT8 BMS_PackSOH = 0x00;					  //ذSOH,,Re-0.4,Off-0,
UINT8 BMS_MaxCellTemp = 0x00;				  //¶,,Re-1,Off--50,
UINT8 BMS_MinCellTemp = 0x00;				  //¶,,Re-1,Off--50,
UINT8 BMS_AverCellTemp = 0x00;				  //ƽ¶,,Re-1,Off--50,
UINT8 BMS_MaxCellTempCSC = 0x00;			  //¶ȵоϵͳ(CSC),Χ(1~255),Re-1,Off-0,
UINT8 BMS_MaxCellTempNum = 0x00;			  //¶ȵоϵͳ(CSC)¶̽,Χ(1~255),Re-1,Off-0,
UINT8 BMS_MinCellTempCSC = 0x00;			  //¶ȵоϵͳ(CSC),Χ(1~255),Re-1,Off-0,
UINT8 BMS_MinCellTempNum = 0x00;			  //¶ȵоϵͳ(CSC)¶̽,Χ(1~255),Re-1,Off-0,
UINT8 BMS_MaxCellVoltCSC = 0x00;			  //ߵѹоϵͳ(CSC),Χ(1~255),Re-1,Off-0,
UINT8 BMS_MaxCellVoltNum = 0x00;			  //ߵѹоϵͳ(CSC)ڵ,Χ(1~255),Re-1,Off-0,
UINT8 BMS_MinCellVoltCSC = 0x00;			  //͵ѹоϵͳ(CSC),Χ(1~255),Re-1,Off-0,
UINT8 BMS_MinCellVoltNum = 0x00;			  //͵ѹоϵͳ(CSC)ڵ,Χ(1~255),Re-1,Off-0,
UINT8 BMS_InsDeteSt = 0x00;					  // BMSԵ״̬,0:ֹͣ;1:;,Re-1,Off-0,
UINT8 BMS_FtCharInsLow = 0x00;				  //Եֵ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtCurrSenr = 0x00;				  //,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtHeatingFilm = 0x00;				  //ĤȻ·,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtMainLoopPreChar = 0x00;			  //·ԤԤ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtAuxLoopPreChar = 0x00;			  //·ԤԤ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtACANLost = 0x00;				  // ACAN/CANͨѶ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtDCDC = 0x00;					  // BMS-DC-DC,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtSOCDif = 0x00;					  // SOC,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtCellOverDisChar = 0x00;			  //оŹ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtCharOver = 0x00;				  //شװù䱨,0:;1:1 ΢;2:2 ع3 : 10 ع, Re - 1, Off - 0,
UINT8 BMS_FtContDisCharCurrOverLoad = 0x00;	  //س,0:;1:1 ΢;2:2 ع3 : 10 ع, Re - 1, Off - 0,
UINT8 BMS_FtContCharCurrOverLoad = 0x00;	  //ŵ,0:;1:1 ΢;2:2 ع3 : 10 ع, Re - 1, Off - 0,
UINT8 BMS_Gun1DCNegTemp = 0x00;				  //1¸ֵ,,Re-1,Off--40,
UINT8 BMS_Gun1DCPosTemp = 0x00;				  //1¸ֵ,,Re-1,Off--40,
UINT8 BMS_Gun2DCNegTemp = 0x00;				  //2¸ֵ,,Re-1,Off--40,
UINT8 BMS_Gun2DCPosTemp = 0x00;				  //2¸ֵ,,Re-1,Off--40,
UINT8 BMS_CurrHeatSt = 0x00;				  //ǰ״̬,0:δ;1:;2:Ԥ;3:Ч;,Re-1,Off-0,
UINT8 BMS_CurrCoolSt = 0x00;				  //ǰȴ״̬,0:δȴ;1:ȴ;2:Ԥ;3:Ч;,Re-1,Off-0,
UINT8 BMS_FtCharCnct = 0x00;				  //ǹź쳣,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtOverDisCharCurrDuringChar = 0x00; //ʱŵ,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtCharNTC = 0x00;					  //NTC,0:; 1:,Re-1,Off-0,
UINT8 BMS_FtELock = 0x00;					  //,0:; 1:,Re-1,Off-0,
UINT8 BMS_CellVoltFramNum = 0x00;			  //ѹ֡,Чֵ1~255,Re-1,Off-0,
UINT8 BMS_CellTempFramNum = 0x00;			  //¶֡,Чֵ1~255,Re-1,Off-0,
UINT8 BMS_CSC_Code = 0x00;					  //ϵͳCSC,Чֵ1~255,Re-1,Off-0,
UINT8 BMS_CellTemp[64] = {0x00};			  //ǰCSCµĵN̽¶,255 "Invalid" 0xFF ЧЧֵ 0 ~254, λ , Χ(-50 ~204), , Re - 1, Off-- 50,
UINT8 BMS_Checksum = 0x00;					  //رϢ1CheckSum,Byte0=Byte1 XOR Byte2 XOR Byte3 XOR Byte4 XOR Byte5 XOR Byte6 XOR Byte7,Re-1,Off-0,
UINT8 BMS_PackComp = 0x00;					  //س,1:"CATL" 2:"Li Shen" 3:"MGL" 4:"SAMSUN" 5:"LG",Re-1,Off-0,
UINT8 BMS_BattCodeLeng = 0x00;				  //ر볤,0:Do not transmit this Code,Re-1,Off-0,
UINT8 BMS_SN[27] = {0x00};					  //ر(SN)ַ1(ASCII),,Re-1,Off-0,
UINT8 BMS_BattType = 0x00;					  //,1:Ǧ; 2:; 3:﮵; 4:﮵; 5:﮵; 6:Ԫϵ; 7:ۺӵ; 8:﮵; 9:; 10~13:; 14:ȼϵ;15:,Re-1,Off-0,
UINT8 BMS_CoolType = 0x00;					  //ȴʽ,0:ȴʽ1 : Ȼȴ 2 : ȴ 3 : ˮȴ, Re - 1, Off - 0,
UINT8 BMS_CSC_Total = 0x00;					  //ϵͳCSCܵĿ,,Re-1,Off-0,
UINT8 BMS_CellVoltLevel = 0x00;				  //ƽ̨ѹ(ʵʱ仯ֵ),Чֵ0~5V;  255 "Signal Invalid" 0xFF Ч,Re-0.1,Off-0,V
UINT8 BMS_CellMinVolt = 0x00;				  //͵ѹ(ʵʱ仯ֵ),Чֵ0~5V;  255 "Signal Invalid" 0xFF Ч,Re-0.1,Off-0,V
UINT8 BMS_CellMaxVolt = 0x00;				  //ߵѹ(ʵʱ仯ֵ),Чֵ0~5V;  255 "Signal Invalid" 0xFF Ч,Re-0.1,Off-0,V
UINT8 BMS_HVBranNum = 0x00;					  //ϵͳѹ֧·,,Re-1,Off-0,
UINT8 BMS_SingleHVBranchCellNum = 0x00;		  //ϵͳ֧·о,,Re-1,Off-0,
UINT8 BMS_ReqMode = 0x00;					  // BMS趨ģʽ,0:ػģʽ1 : ģʽ 2 : ģʽ 3 : ѭģʽ, Re - 1, Off - 0,
UINT8 BMS_HVCmd = 0x00;						  //ѹ,0:ϸѹ1 : ¸ѹ, Re - 1, Off - 0,
UINT8 BMS_ChgSts = 0x00;					  //״̬,0:ǳ1 : , Re - 1, Off - 0,
UINT8 BMS_HVRelaySts = 0x00;				  // BMSѹ̵״̬,0:Ͽ״̬; 1:պ״̬; 2~3:Ч,Re-1,Off-0,
UINT8 BMS_SetTemp = 0x00;					  //趨¶,,Re-1,Off--40,
UINT8 BMS_Life = 0x00;						  // BMS֡,,Re-1,Off-0,
UINT8 BMS_CRC = 0x00;						  // CRCУֵ,,Re-1,Off-0,
UINT8 TMS_WorkStatus = 0x00;				  // TMS״̬,0:ػģʽ1 : ģʽ 2 : ģʽ 3 : ѭģʽ, Re - 1, Off - 0,
UINT8 TMS_HVRelayST = 0x00;					  // TMSѹ̵״̬,0:Ͽ״̬; 1:պ״̬; 2~3:Ч,Re-1,Off-0,
UINT8 TMS_OutletTemp = 0x00;				  //ˮ¶(鵽),255:Ч,Re-1,Off--40,
UINT8 TMS_InletTemp = 0x00;					  //ˮ¶(ص),255:Ч,Re-1,Off--40,
UINT8 TMS_ErrCode = 0x00;					  // TMS,0:޹;  1 ѭ,Re-1,Off-0,
UINT8 TMS_FaultLevel = 0x00;				  // TMSȼ,0:Ч1 : 1 2 : 2 3 : 3, Re - 1, Off - 0,
UINT16 BMS_SoftwareVersion = 0x00;			  //汾:RyyyBzzz(RΪ汾BΪ԰汾ʽ汾B)  ,yyy:0~254,1,255:Ч,ʾ;zzz:0~254,1,255:Ч,ʾ;
UINT16 BMS_HardwareVersion = 0x00;			  //Ӳ汾:VyyyBzzz(VΪӲ汾BΪ԰汾ʽ汾B)  ,,Re-1,Off-0,
UINT16 BMS_PackCurr = 0x00;					  //ذܵ,Ϊֵ,ŵΪֵ,,Re-0.1,Off--1000,A
UINT16 BMS_MaxCharCurr = 0x00;				  //ذس,,Re-0.1,Off--1000,A
UINT16 BMS_MaxDisCharCurr = 0x00;			  //ذŵ,,Re-0.1,Off--1000,A
UINT16 BMS_PosIns = 0x00;					  //ĸԳԵ,,Re-1,Off-0,K
UINT16 BMS_NegIns = 0x00;					  //ĸ߸ԳԵ,,Re-1,Off-0,K
UINT16 BMS_BattVolt = 0x00;					  //ذڲѹ,,Re-0.1,Off-0,V
UINT16 BMS_LinkVolt = 0x00;					  //ذѹ,,Re-0.1,Off-0,V
UINT16 BMS_MaxCellVolt = 0x00;				  //ߵѹֵ,,Re-0.001,Off-0,V
UINT16 BMS_AverCellVolt = 0x00;				  //оѹƽֵ,,Re-0.001,Off-0,V
UINT16 BMS_MinCellVolt = 0x00;				  //о͵ѹֵ,,Re-0.001,Off-0,V
UINT16 BMS_ContChrgCurr = 0x00;				  // BMSĳس,,Re-0.1,Off-0,A
UINT16 BMS_ContDisCharCurr = 0x00;			  // BMSĳŵ,,Re-0.1,Off--1000,A
UINT16 BMS_CharReqVolt = 0x00;				  //ѹ(),,Re-0.1,Off-0,V
UINT16 BMS_CharReqCurr = 0x00;				  //(),,Re-0.1,Off--1000,A
UINT16 BMS_SysInsRes = 0x00;				  //ϵͳԵ,,Re-1,Off-0,K
UINT16 BMS_MaxDisCharPwr = 0x00;			  //ŵ繦,,Re-0.1,Off-0,kw
UINT16 BMS_MaxCharPwr = 0x00;				  //繦,,Re-0.1,Off-0,kw
UINT16 BMS_ContDisCharPwr = 0x00;			  // BMSĳŵ繦,,Re-0.1,Off-0,kw
UINT16 BMS_ContCharPwr = 0x00;				  // BMSĳ繦,,Re-0.1,Off-0,kw
UINT16 BMS_InstEngyCons = 0x00;				  //˲ʱٹܺ,,Re-0.1,Off-0,kwh
UINT16 BMS_TotalEngyCons = 0x00;			  ///ƽٹܺ,,Re-0.1,Off-0,kwh
UINT16 BMS_SOE = 0x00;						  //ʣ,,Re-0.01,Off-0,kwh
UINT16 BMS_RmanCharTime = 0x00;				  //ʣʱ,,Re-1,Off-0,min
UINT16 BMS_CharNum = 0x00;					  //,,Re-1,Off-0,
UINT16 BMS_CellVolt[384] = {0x00};			  //оĵѹ,65535 "Invalid" 0xFFFF ЧЧֵ 0 ~65534, Χ(0 ~65.534) V, Re - 0.001, Off - 0, V
UINT16 BMS_BattRateCap = 0x00;				  //ذ,Чֵ 0~65534,65535 "Signal Invalid" Ч,Re-1,Off-0,Ah
UINT16 BMS_BattRateVolt = 0x00;				  //ذѹ,Чֵ 0~6553.4,65535 "Signal Invalid" Ч,Re-0.1,Off-0,V
UINT16 BMS_BattRateEngy = 0x00;				  //ذ,Чֵ 0~6553.4,65535 "Signal Invalid" Ч,Re-0.1,Off-0,kWh
UINT16 BMS_CellTotal = 0x00;				  // PACKеоĿ,,Re-1,Off-0,
UINT16 BMS_TempTotal = 0x00;				  // PACKео¶ȵ(̽)Ŀ,,Re-1,Off-0,
UINT16 BMS_SingleCharEngy = 0x00;			  //γkWh ,,Re-0.1,Off-0,KWh
UINT16 BMS_SingleCharCapy = 0x00;			  //γAh ,,Re-0.1,Off-0,Ah
UINT16 BMS_HVVolt = 0x00;					  // BMSǰѹ,,Re-1,Off-0,
UINT16 TMS_ReqPow = 0x00;					  // TMS,65535:Ч,Re-0.1,Off-0,Kw
UINT32 BMS_TotalCharEngy = 0x00;			  //ۼƳkWh ,,Re-0.1,Off-0,KWh
UINT32 BMS_TotalDisCharEngy = 0x00;			  //ۼƷųkWh ,,Re-0.1,Off-0,KWh
UINT32 BMS_TotalBackCharEngy = 0x00;		  //ۼƶܻkWh ,,Re-0.1,Off-0,KWh
UINT32 BMS_TotalStaCharEngy = 0x00;			  //ۼƻվkWh ,,Re-0.1,Off-0,KWh
UINT32 BMS_TotalGunCharEngy = 0x00;			  //ۼƲǹkWh ,,Re-0.1,Off-0,KWh
UINT32 BMS_TotalGunCharCapy = 0x00;			  //ۼƲǹAh ,,Re-0.1,Off-0,Ah
UINT32 BMS_TotalCharCapy = 0x00;			  //ۼƳAh ,,Re-0.1,Off-0,Ah
UINT32 BMS_TotalDisCharCapy = 0x00;			  //ۼƷųAh ,,Re-0.1,Off-0,Ah
UINT32 BMS_TotalBackCharCapy = 0x00;		  //ۼƶܻAh ,,Re-0.1,Off-0,Ah
UINT32 BMS_TotalStaCharCapy = 0x00;			  //ۼƻվAh ,,Re-0.1,Off-0,Ah
/*VCU->EBCź*****************************************/
UINT32 VcuInTable[4] = {
	0x18F101D0,
	0x18F103D0,
	0x18E1F3D0,
	0x18FEF100};
BOOL VcuRxShortError[4];
BOOL VcuRxLongError[4];
UINT8 VcuRxFlag[4];
UINT8 VcuRxErrorCounter[4];
UINT8 VCU_Num_VIN[17];			// VCU-VIN
UINT8 VCU_St_VinRecv;			// VIN״̬
UINT8 VCU_St_BattRly = 0x00;	//ؽӴ״̬,0:պϣָʾ 1:Ͽָʾ 2:Ԥ 3:Ч,R-1,Off-0,
UINT8 VCU_St_Check = 0x00;		// VCUԼ״̬,0:Լ 1:Լɹ 2:Լʧ 3:Ч,R-1,Off-0,
UINT8 VCU_St_SysIntLock = 0x00; //ϵͳ״̬,0:ûл 1:绥 2:Ԥ 3:Ч,R-1,Off-0,
UINT8 VCU_St_Veh = 0x00;		//״̬,0:Wait 1:Ready 2:Ԥ 3:Ч,R-1,Off-0,
UINT8 VCU_St_Gear = 0x00;		//λ״̬, -1:  0:յ  1:1  2:2  3:3  4:4  5:5  6:6  7:7  8:8  9:9  10:10  11:11  12:12  13:13  14:14Ч ,R-1,Off--125,
UINT8 VCU_Ft_Sys = 0x00;		// VCUϣMCUϵͬһţ,0:޹ 1:ϵͳ,R-1,Off-0,
UINT8 VCU_Ft_Tran = 0x00;		//,0: 1:,R-1,Off-0,
UINT8 VCU_Ft_BattSys = 0x00;	//ϵͳ,0: 1:,R-1,Off-0,
UINT8 VCU_State_Veh = 0x00;		//״̬,1:״̬ 2:Ϩ 3:״̬ 14:쳣 15:Ч,R-1,Off-0,
UINT8 VCU_Counter = 0x00;		//ѭ,,R-0.1,Off-0,
UINT8 VCU_SoftVersion = 0x00;	// VCU汾,,R-0.1,Off-0,
UINT8 VCU_St_AccPedal = 0x00;	//̤״̬,,R-0.4,Off-0,
UINT8 VCU_St_BrakePedal = 0x00; //ɲ̤״̬,,R-0.4,Off-0,
UINT8 VCU_St_ParkBrakeSw = 0;	//ɲ״̬
// declear the UINT16 vars
UINT16 VCU_VehSpd = 0x00;	//,,R-0.0039,Off-0,Km/h
UINT16 VCU_RemaMile = 0x00; //ʣ,,R-0.125,Off-0,Km
/*EBC->CANź*****************************/
UINT32 EbcOutTable[2][2] =
	{{0x18FFF8A7, 100},
	 {0x18FEF8A7, 100}};
UINT8 EBC_Counter = 0;		   // EBC_Counter	LIFE ź
UINT8 EBC_LockSt = 0;		   // EBC_LockSt	ֹ״̬
UINT8 EBC_CnctSt = 0;		   //״̬·&ŵ·ͬʱպϴպϣһ·ϿΪϿ
UINT8 EBC_DisCharCnctSt = 0;   //	ŵ·״̬()
UINT8 EBC_CharCnctSt = 0;	   //	·״̬
UINT8 EBC_FtLvl = 0;		   //ϵͳϵȼ
UINT8 EBC_FtCode = 0;		   //ϵͳ
UINT8 EBC_AirPressure = 0;	   //ѹֵ
UINT8 EBC_CharSt = 0;		   //־λ
UINT8 EBC_ActHeatReq = 0;	   //Ԥ
UINT8 EBC_InhiHVOn = 0;		   //ֹѹϵ
UINT8 EBC_ReqHVOff = 0;		   //ѹµ
UINT8 EBC_StopChgCmd = 0;	   //ָֹͣ
UINT8 EBC_State = 0;		   //״̬
UINT8 EBC_DisCharPos1Temp = 0; //ŵ1¶
UINT8 EBC_DischarNeg1Temp = 0; //ŵ縺1¶
UINT8 EBC_DisCharPos2Temp = 0; //ŵ2¶
UINT8 EBC_DisCharNeg2Temp = 0; //ŵ縺2¶
UINT8 EBC_ChgPos1Temp = 0;	   //1¶()
UINT8 EBC_ChgNeg1Temp = 0;	   //縺1¶()
UINT8 EBC_ChgPos2Temp = 0;	   //2¶()
UINT8 EBC_ChgNeg2Temp = 0;	   //縺2¶()

/*************************************************************
 *Ebc->BleԼEbcӦò
 ************************************************************/
uint8 g_c_BlePwr = 0;
uint8 g_c_AirPwr = 0;
uint8 g_c_LedPwr = 0;
uint16 bcud_E_snglChrg; //γ0.1kwh

uint16 bcud_pct_soc;		 //SOC0.1
uint16 bcud_Q_snglChrg;		 //γ0.1Ah
uint16 bcud_V_battU;		 //صѹ 0.1V
uint32 bcud_E_accChrg;		 //ۼƳ0.1kwh
uint32 bcud_E_accDischrg;	 //ۼƷŵ0.1kwh
uint32 bcud_E_accPlugInChrg; //ۼƲǹ0.1kwh
uint32 bcud_E_accRecovry;	 //ۼƻ0.1kwh
uint32 bcud_E_accSwapBatt;	 //ۼƻվ0.1kwh
uint32 bcud_Q_accChrg;		 //ۼƳ0.1ah
uint32 bcud_Q_accDischrg;	 //ۼƷŵ0.1ah
uint32 bcud_Q_accPlugInChrg; //ۼƲǹ0.1ah
uint32 bcud_Q_accRecovry;	 //ۼƻ0.1ah
uint32 bcud_Q_accSwapBatt;	 //ۼƻվ0.1ah
uint32 vcud_M_accDrv;		 //ۼʻ,0.1km
uint8 bcud_pct_bcuSoh;		 //Soh0.4%
uint8 bcud_st_bcuComun;		 //ͨѶ״̬,0-ͨж,1-ͨ
uint8 bcud_st_bcuMainRelay;	 //̵ź,0- 1-Ͽ,2-ر 3-쳣
uint8 bcud_st_bcuTmsLiquid;	 //ȹҺλ״̬,1-Һλ,0-Һλ
uint8 bcud_st_hvWork;		 //ظѹ״̬0-ѹ 1-Ԥ䣬2-ѹضϣ3-ѹϵ
uint8 bcuv_Num_battSn[32];	 //SN

uint8 vcud_P_airSensorBack;			   //ѹֵλMpa0.01Mpa
uint8 vcud_P_airSensorForward;		   //ǰѹֵλMpa0.01Mpa
uint8 vcud_st_carStart;				   //״̬0001-״̬0010-Ϩ0011-״̬1111-Ч
uint8 vcud_st_footbrake;			   //ɲźţ0-Ч1-Ч
uint8 vcud_st_gear;					   //λźţFF-R0-յNX-ǰDXXȡ1-12
uint8 vcud_st_handbrake;			   //ɲźţ0-Ч1-Ч
uint8 vcud_st_keyOn;				   //Կźţ1-ϵ磬0-µ
uint8 vcud_st_Steer;				   //źţbit0-תƣbit1-Ҳתƣÿbit 0-OFF1-ON
uint8 vcud_st_vcuComun;				   // vcuͨѶ״̬0-ͨж,1-ͨ
uint8 vcuv_Num_vin[17];				   // VIN
uint8 bled_flg_lockCmd = 0;			   //ŷ1-Ч0-Ч
uint8 bled_flg_unlockCmd = 0;		   //ŷ1-Ч0-Ч
uint8 bled_flg_lockCmdForce = 0;	   //ŷǿ1-Ч0-Ч
uint8 bled_flg_unlockCmdForce = 0;	   //ŷǿ1-Ч0-Ч
uint8 bled_flg_topAscendCmd = 0;	   //1-Ч0-Ч
uint8 bled_flg_topDescendCmd = 0;	   //½1-Ч0-Ч
uint8 bled_flg_topAscendCmdForce = 0;  //ǿ1-Ч0-Ч
uint8 bled_flg_topDescendCmdForce = 0; //ǿ½1-Ч0-Ч
uint8 bled_flg_openDustReCmd = 0;	   //ָ1-Ч0-Ч
uint8 bled_flg_closeDustReCmd = 0;	   //رָ1-Ч0-Ч
uint8 bled_flg_Heart = 0;			   //άָ
uint8 bled_flg_getEbcData = 0;		   //ȡebcָ
uint8 bled_flg_getVcuData = 0;		   //ȡvcuָ
uint8 bled_flg_getBmsData = 0;		   //ȡbmsָ
uint8 bled_flg_handShake = 0;		   //ָ
uint8 bled_flg_swapBattDone = 0;	   //ָ
uint8 bled_flg_backToDrv = 0;		   //صʻ״ָ̬
uint8 bled_flg_autoLock = 0;		   //Զָ
uint8 bled_flg_autoUnlock = 0;		   //Զָ
uint8 bled_flg_toSwapMod = 0;		   //״̬
uint8 bled_flg_safeStopCmd = 0;		   //ָͣ
uint32 bled_Nr_softVer = 0;			   // BLE汾
uint8 bled_flg_role = 0;			   // bleģʽ 01-02-
uint8 bled_flg_bleConn = 0;			   // ble״̬
uint8 bled_flg_bleDisconn = 0;		   // bleϿ״̬
uint8 bled_st_dataTrans = 0;		   //ݴ״̬
/*
ebcӦò
*/
uint8 ebcd_flg_Can2SendEnbale = 0;	 //ӦBLEʹ
uint8 ebcd_st_toBleAns = 0;			 //ӦBLEָ
uint8 ebcd_P_airSensor = 0;			 //ѹѹֵλMpa0.01Mpa
uint8 ebcd_T_plugin[4] = {0};		 //ĸӲ¶ȣƫ40
uint8 ebcd_flg_forbidHVOn = 0;		 //ֹѹϵ BMS
uint8 ebcb_flg_reqHvOff = 0;		 //ѹµ BMS
uint8 ebcd_flg_LockErr = 0;			 //״̬,0-쳣1-
uint8 ebcd_flg_dChrgLockErr = 0;	 //ŵ绥״̬
uint8 ebcd_flg_chrgLockErr = 0;		 //绥״̬
uint8 ebcd_flg_dChgCnctOverTemp = 0; //ŵ±־
uint8 ebcd_st_ebcWork = DriveMode;	 // Ebcǰ״̬ 0-г1-ͨѶֲŽͨѶ״̬2-
uint8 ebcd_Nr_errMax;				 //ϵȼǰȼ
uint8 ebcd_Num_faultCode;			 // ebc룬δ
uint8 ebcd_st_chargingMod;			 //ģʽ1-س磬2-վ
uint8 ebdc_st_lockUpState = 0;		 //ֹ״̬0-ϣ1-ɹ2-ɹ
uint8 ebdc_st_ConnecState = 0;		 //״̬·&ŵ·ͬʱպϴպϣһ·ϿΪϿ0_δ 1_
uint8 ebcd_flg_pluginLockSig;		 //Ӳź״̬,1-,0-޴
uint8 ebcd_flg_swapAdmit;			 //жϣ0-,1-
uint8 ebcd_Num_err1;				 //1
uint8 ebcd_Num_err2;				 //2
uint8 ebcd_st_ebcConnect;			 // EbcͨѶģʽ0-1- Ĭ0
uint8 ebcd_st_ebcLockWork;			 // Ebcģʽ0-ģʽ1-Զģʽ
uint8 ebcd_st_errTable1;			 //ϱ1bit0-ѹ쳣bit1-Һλ쳣bit2-Flashȡ쳣
uint8 ebcd_st_errTable2;			 //ϱ2bit0-쳣bit1-CAN쳣bit2-CAN쳣bit3-쳣bit4-쳣bit5-λ쳣
uint8 ebcd_st_errTable3;			 //ϱ3bit0-ŵ绥쳣bit1-绥쳣bit2-ѹ쳣
uint8 ebcd_st_lockSensor;			 //źţbit0-bit30-3״̬ÿbit1-0-
uint8 ebcd_st_lockSucJug;			 //жϣ0-ȫδ,1-ȫ,2-δȫ"
uint8 ebcd_st_pedstSensor;			 //bit0-bit10-1״̬,ÿbit1-0-޴
uint8 ebcd_st_pedstSucJug;			 //صλжϣ0-ȫδλ,1-ȫλ,2-δȫλ
uint8 ebcd_st_pluginLockSig;		 //Ӳźž״̬,1-,0-޴
uint8 ebcd_st_unlockSensor;		 //źţbit0-bit30-3״̬ÿbit1-0-
uint8 ebcd_st_unlockSucJug;			 //жϣ0-ȫδ1-ȫ2-δȫ
uint8 m_flg_HVlock1 = 0;			 //״̬1ػӲ
uint8 m_flg_HVlock2 = 0;			 //״̬2ŵӲ
uint16 Test_LockPressure = 0;		 //
uint8 ebcd_flg_ebcManCtrlEn = 0;	 // EBCֶʹ
uint8 ebcd_flg_ebcManCtrlMode = 0;	 // EBCֶģʽ

#define EEPDATA_START_SEC_VAR
#include "MemMap.h"
uint16 ebcd_Nr_swapBatt;	//
uint16 ebcd_Nr_swapSucBatt; //ɹ
uint16 ManuControlTimes = 0;
uint16 LockDelayTime = 0;	//ʱʱ䣨λԺʱʱȷΪɹ
uint16 UnlockDelayTime = 0; //ʱʱ䣨λԺʱʱȷΪɹ

uint8 sfmv_Num_FltEEsave = 0;
#define EEPDATA_STOP_SEC_VAR
#include "MemMap.h"
#define APPLAYERVER_START_SEC_VAR
#include "MemMap.h"
const uint8 T_table[240] = {239, 238, 237, 236, 235, 234, 233, 232, 231, 230, 229, 228, 227, 226, 225, 224,
							223, 222, 221, 220, 219, 218, 217, 216, 215, 214, 213, 212, 211, 210, 209, 208, 207, 206, 205, 204, 203,
							202, 201, 200, 199, 198, 197, 196, 195, 194, 193, 192, 191, 190, 189, 188, 187, 186, 185, 184, 183, 182,
							181, 180, 179, 178, 177, 176, 175, 174, 173, 172, 171, 170, 169, 168, 167, 166, 165, 164, 163, 162, 161,
							160, 159, 158, 157, 156, 155, 154, 153, 152, 151, 150, 149, 148, 147, 146, 145, 144, 143, 142, 141, 140,
							139, 138, 137, 136, 135, 134, 133, 132, 131, 130, 129, 128, 127, 126, 125, 124, 123, 122, 121, 120, 119,
							118, 117, 116, 115, 114, 113, 112, 111, 110, 109, 108, 107, 106, 105, 104, 103, 102, 101, 100, 99, 98, 97,
							96, 95, 94, 93, 92, 91, 90, 89, 88, 87, 86, 85, 84, 83, 82, 81, 80, 79, 78, 77, 76, 75, 74, 73, 72, 71, 70, 69,
							68, 67, 66, 65, 64, 63, 62, 61, 60, 59, 58, 57, 56, 55, 54, 53, 52, 51, 50, 49, 48, 47, 46, 45, 44, 43, 42, 41,
							40, 39, 38, 37, 36, 35, 34, 33, 32, 31, 30, 29, 28, 27, 26, 25, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13,
							12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0};
const uint32 R_table[240] = {125, 127, 129, 131, 133, 136, 138, 141, 143, 145, 148, 151, 153, 156, 159, 162, 165,
							 168, 171, 174, 177, 180, 183, 187, 190, 194, 198, 201, 205, 209, 213, 217, 221, 226, 230, 234, 239, 244, 249,
							 254, 259, 264, 269, 274, 280, 286, 292, 298, 304, 310, 316, 323, 330, 337, 344, 351, 359, 366, 374, 382, 391,
							 399, 408, 417, 426, 436, 445, 455, 466, 476, 487, 498, 509, 521, 533, 546, 558, 571, 585, 599, 613, 627, 642,
							 658, 674, 690, 707, 724, 742, 760, 779, 799, 819, 839, 861, 883, 905, 928, 952, 977, 1002, 1029, 1056, 1083,
							 1112, 1142, 1172, 1204, 1236, 1270, 1305, 1340, 1377, 1415, 1455, 1495, 1537, 1581, 1626, 1672, 1720, 1769,
							 1821, 1874, 1928, 1985, 2044, 2104, 2167, 2232, 2299, 2369, 2441, 2515, 2592, 2672, 2755, 2841, 2931, 3023,
							 3119, 3218, 3321, 3428, 3539, 3654, 3773, 3898, 4026, 4160, 4299, 4443, 4593, 4749, 4911, 5080, 5255, 5438,
							 5627, 5825, 6030, 6244, 6466, 6698, 6940, 7191, 7454, 7727, 8012, 8309, 8619, 8942, 9280, 9632, 10000, 10383,
							 10784, 11203, 11641, 12098, 12577, 13077, 13600, 14147, 14720, 15319, 15947, 16604, 17293, 18015, 18771,
							 19564, 20395, 21268, 22183, 23144, 24152, 25211, 26324, 27493, 28722, 30014, 31373, 32802, 34307, 35891,
							 37558, 39315, 41166, 43117, 45174, 47343, 49633, 52049, 54599, 57293, 60140, 63148, 66329, 69693, 73252,
							 77019, 81008, 85233, 89710, 94455, 99488, 104827, 110493, 116508, 122898, 129687, 136905, 144580,
							 152746, 161438, 170694, 180554, 191063, 202269};

const uint8 DataPackCounter[21] = {1, 1, 7, 5, 16, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
const uint8 DataPackBegin[21] = {0, 0x11, 0x21, 0x31, 0x40, 0x51, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
#define APPLAYERVER_STOP_SEC_VAR
#include "MemMap.h"
